import numpy as np
from math import exp
import math

class Two_Stage_MLE_Model:
    def __init__(self,data,data_label):
        self.data_points = data.T
        self.num_control_data = int(math.sqrt(self.data_points.shape[0]))
        self.num_target_data = self.data_points.shape[0] - self.num_control_data
        self.data_label = data_label
        
    def train_worker_set(self,set_of_workers_id): 
        self.worker_bias = np.mean(self.data_points[0:self.num_control_data][set_of_workers_id] - data_label[0:self.num_control_data].reshape(self.num_control_data,1),axis=0)

        test_data = self.data_points[self.num_control_data:]
        self.worker_variance = np.std(self.data_points[0:self.num_control_data] - data_label[0:self.num_control_data].reshape(self.num_control_data,1),axis=0)
        self.estimated_value_mle = np.mean(test_data - worker_bias,axis=1)
        self.reputation_mle = 1/self.worker_variance